#include <iostream>
using namespace std;
long long mas[1000000][2];
long long stupka[1000000];
int main (){
long long sum=0;
mas[0][0]=0;
mas[0][0]=0;
stupka[0]=0;
long long N;
cin>>N;
for (int i=1; i<=N; i++){
    cin>>mas[i][0]>>mas[i][1];
    if (mas[i][1]>0) stupka[i]=stupka[mas[i][0]]+mas[i][1];
    else stupka[i]=stupka[mas[i][0]]-mas[mas[i][0]][1];
    sum=sum+stupka[i];
}
cout<<sum;
return 0;
}
